import * as React from "react";
import { Base, Question, SurveyError } from "survey-core";
import { SurveyElementBase } from "survey-react-ui";
import { ICreatorOptions, SurveyCreatorModel, ITabbedMenuItem } from "survey-creator-core";
interface ISurveyCreatorComponentProps {
    creator: SurveyCreator;
    style?: any;
}
export declare class SurveyCreatorComponent extends SurveyElementBase<ISurveyCreatorComponentProps, any> {
    constructor(props: ISurveyCreatorComponentProps);
    get creator(): SurveyCreatorModel;
    protected getStateElement(): Base;
    get style(): any;
    componentDidUpdate(prevProps: any, prevState: any): void;
    componentDidMount(): void;
    componentWillUnmount(): void;
    private rootNode;
    renderElement(): React.JSX.Element;
    renderActiveTab(): React.JSX.Element;
    renderCreatorTab(tab: ITabbedMenuItem): React.JSX.Element;
    renderSidebar(): any;
}
export declare class SurveyCreator extends SurveyCreatorModel {
    constructor(options?: ICreatorOptions, options2?: ICreatorOptions);
    render(target: string | HTMLElement): void;
    createQuestionElement(question: Question): React.JSX.Element;
    renderError(key: string, error: SurveyError, cssClasses: any): React.JSX.Element;
    questionTitleLocation(): string;
    questionErrorLocation(): string;
}
export {};
