import * as React from "react";
import { Base, PageModel, SurveyModel } from "survey-core";
import { CreatorModelElement } from "../ModelElement";
import { SurveyCreatorModel, PageAdorner } from "survey-creator-core";
interface ICreatorSurveyPageComponentProps {
    creator: SurveyCreatorModel;
    survey: SurveyModel;
    page: PageModel;
    isGhost: boolean;
}
export declare class CreatorSurveyPageComponent extends CreatorModelElement<ICreatorSurveyPageComponentProps, any> {
    private model;
    private rootRef;
    constructor(props: ICreatorSurveyPageComponentProps);
    protected createModel(props: ICreatorSurveyPageComponentProps): void;
    protected createPageAdorner(creator: SurveyCreatorModel, page: PageModel): PageAdorner;
    shouldComponentUpdate(nextProps: any, nextState: any): boolean;
    componentDidUpdate(prevProps: any, prevState: any): void;
    protected getUpdatedModelProps(): string[];
    protected getStateElement(): Base;
    componentDidMount(): void;
    componentWillUnmount(): void;
    protected canRender(): boolean;
    renderElement(): React.JSX.Element;
    protected renderPlaceholder(): React.JSX.Element;
    protected renderContent(): React.JSX.Element;
    protected renderHeader(): React.JSX.Element;
    protected renderFooter(): React.JSX.Element;
}
export {};
